• 微信公众号:美女很有趣。 工作之余,放松一下,关注即送10G+美女照片!

JavaSE_异常

开发技术 开发技术 2周前 (05-03) 9次浏览

异常

什么是异常

  • 实际工作中,遇到的情况不可能是非常完美的。比如:你写的某个模块,用户输入不一定符合你的要求、你的程序要打开某个文件,这个文件可能不存在或者文件格式不对,你要读取数据库的数据,数据可能是空的等。我们的程序跑着,内存或硬盘可能满了。等等。
  • 软件程序再运行过程中,非常可能遇到刚刚提到的这些已成问题,我们叫做异常(Exception(例外))。这些,例外情况,或者叫异常,怎么让我们写的程序做出合理的处理。而不至于程序崩溃。
  • 异常指程序运行中出现的不期而至的各种情况,如:文件找不到、网络连接失败、非法参数等。
  • 异常发生在程序运行期间,它影响了正常程序执行流程。

简单分类

  • 要理解Java异常处理是如何工作的
  • 异常分类
    • 检查性异常
      • 最具代表的检查性异常是用户错误或问题引起的异常,这是程序员无法预见的。例如要打开一个不存在的文件时,一个异常就发生了,这些异常在编译时不能被简单地忽略。
    • 运行时异常
      • 运行时异常是可能被程序员避免的异常。与检查性异常星饭,运行时异常可以在编译时被忽略。
    • 错误
      • 错误不是异常,二十脱离昌旭源控制的问题。错误在代码中通常被忽略。例如,当栈溢出时,一个错误就发生了,他们在编译时也检查不到。

异常体系结构

  • Java吧异常当做对象来处理,并定义一个基类java.lang.Throwable作为所有异常的超类。
  • 在Java API中已经定义了许多异常类,这些异常类分为两大类,错误(Error)和异常(Exception)

JavaSE_异常

Error

  • Error类对象由Java虚拟机生成并抛出,大多数错误与代码编写者所执行的操作无关。
  • Java虚拟机运行错误(Virtual MachineError),当JVM不在有继续执行操作所需的内存资源时,将出现OutOfMemoryError。这些异常发生时,Java虚拟机(JVM)一般会选择线程终止;
  • 还有发生在虚拟机试图执行应用时,如类定义错误(NoClassDefFoundError),链接错误(LinkageError).这些错误是不可查的,因为它们在程序的控制和处理能力之外,而且绝大多数是程序运行时不允许出现的状况。

Exception

  • 在Exception分支中有一个重要的子类RuntimeException(运行时异常)

    • ArrayIndexOutOfBoundsException(数组下标越界)
    • NullPointerException(空指针异常)
    • ArithmeticException(算术异常)
    • MissingResourceException(丢失资源)
    • ClassNotFoundException(找不到类)

等异常,这些异常是不检查异常,程序中可以选择捕获处理,也可以不处理

  • 这些异常一般是由程序逻辑错误引起的,程序应该从逻辑角度尽可能避免这类异常的发生;

  • Error和Exception的区别:

    • Error通常是灾难性的致命的错误,是程序无法控制和处理的,当出现这些异常时,Java虚拟机(JVM)一般会选择终止线程
    • Exception通常情况下是可以被程序处理的,并且在程序中应该尽可能去处理这些异常。

异常处理机制

  • 抛出异常
  • 捕获异常
  • 异常的5个关键字
    • try
    • catch
    • finally
    • throw
    • throws
public class Appcational{
    public static void main(String[] args){
        int a = 1;
        int b = 0;
        System.out.println(a/b);
        /*我们都知道0是不可以作为除数的
        所以,这里程序执行时会抛出一个异常ArithmeticException(算术异常)
        然后程序终止·····
        那么····有没有什么办法可以避免呢?
        */
    }
}

使用try-catch啊

public class Appcational{
    public static void main(String[] args){
        int a = 1;
        int b = 0;
        try{
            System.out.println(a/b);
        }catch(ArithmeticException e){
            System.out.println("除数不能为0!!!");
        }
    }
}

此时,运行结果为:

除数不能为0!!!

这里catch可以想if-else中else if()一样使用,不过,catch后的异常大小要逐渐递增(异常大小看”异常体系结构”)不然会报错!!!

public class Appcational{
    public static void main(String[] args){
        try{
        }catch(ArithmeticException e){
        }catch(Exception e){
        }catch(Throwable e){
        }
    }
}

话说·····finally、throw、throws呢?

(⊙o⊙)…

finally是用于处理善后工作的,不管有没有异常都会执行的:

public class Appcational{
    public static void main(String[] args){
        int a = 1;
        int b = 0;
        try{
            System.out.println(a/b);
        }catch(ArithmeticException e){
            System.out.println("除数不能为0!!!");
        }finally{
            System.out.println("finally");
        }
    }
}

此时,运行结果为:

除数不能为0!!!
finally

throw

这通常用于方法中

public class Appcational{
    public static void main(String[] args){
        new Application().test();
    }
    public void test(int a,int b){
        if(b==0){
            throw new ArithmeticException();
        }
    }
}

我们都知道,正常情况下这种操作是不会报出异常的

but

你大可去运行一下这段代码看看

throws

假设这方法中处理不了这个异常,就需要把异常抛出去

如果一个方法没有捕获到一个检查性异常,那么该方法必须使用 throws 关键字来声明。throws 关键字放在方法签名的尾部。

public class Appcational{
    public void test(int a,int b)throws ArithmeticException{
    }
}

一个方法可以声明抛出多个异常,多个异常之间用逗号隔开

自定义异常

  • 使用Java内置的异常类可以描述在编程时出现的大部分异常情况。除此之外,用户还可以自定义异常。用户自定义异常,只需继承Exception类即可。
  • 在程序中使用自定义异常类,大体可分为一下几个步骤:
    • 创建自定义异常类。
    • 在方法中通过throw关键字抛出异常。
    • 如果在当前抛出异常的方法中处理异常,可以使用try-catch语句捕获并处理;否则在方法的声明处通过throws关键字指明要抛出给方法调用者的异常,继续进行下一步操作。
    • 在出现异常方法的调用者中捕获并处理异常。

下面,我们来自定义一个异常

public class MyException extends Exception{
    
    private int detail;
    public MyException(int a){
        this.detail = a;
    }
    public String toString(){
        return "MyException{" + "detail=" + detail + '}';
    }
}

再写一个测试类

public class Test{
    public static void main(String[] args){
        try{
            test(10);
        }catch(MyException e){
            System.out.println("变量a必须小于10!!!")
        }
    }
    static void test(int a){
        if(a>=10){
            //抛出异常
            throw new MyException(a);
        }
    }
}

实际应用中的经验总结

  • 处理运行时异常时,采用逻辑去河里规避同时辅助try-catch处理
  • 在多重catch块后面,可以加一个catch(Exception)来处理可能会被遗漏的异常
  • 对于不确定的代码,也可以加上try-catch,处理潜在的异常
  • 尽量去处理异常,切忌只是简单地调用printlnStackTrace()去打印输出
  • 具体如何处理异常,要根据不同业务需求和异常类型去决定
  • 尽量添加finally语句块去释放占用的资源

程序员灯塔
转载请注明原文链接:JavaSE_异常
喜欢 (0)